#---------------------------------------------------------------------------
#
#   SuPy GUI - Button base - Generic
#
#---------------------------------------------------------------------------

from properties import overridable_property
from widget import Widget

class GButtonBase(Widget):

	title = overridable_property('title', "Title string of the button")
	action = overridable_property('action', "Action to perform when clicked")

	_action = None
	
	def get_action(self):
		return self._action
	
	def set_action(self, x):
		self._action = x
	
	def do_action(self):
		self.invoke_action(self.action)
	
	def invoke_action(self, action):
		if isinstance(action, str):
			self.handle(action)
		elif isinstance(action, tuple):
			self.handle(*action)
		else:
			action()
